SystemOrganization addCategory: #'DAO-TP-Changes'!

Error subclass: #UnidadDeTrabajoException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

Object subclass: #Cambio
	instanceVariableNames: 'nombreDeCategoria nombreDeClase autor fechaYHora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!Cambio class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:53'!
esteTipo: unNombreDeUsuario aEstaHora: unaHora hizo: unEvento
	^self new esteTipo: unNombreDeUsuario aEstaHora: unaHora creo: unEvento classAdded name enLaCategoria: unEvento classCategory.	! !

!Cambio class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 17:23'!
for: unEvento
	^self new initializeWithThisCategoryName: unEvento classCategory andThisClassName: unEvento classAdded name.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:09'!
autor
	^autor.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:59'!
esteTipo: unNombreDeUsuario aEstaHora: unaHora creo: unNombreDeClase enLaCategoria: unaCategoria
	autor := unNombreDeUsuario.
	fechaYHora := unaHora.
	nombreDeClase := unNombreDeClase.
	nombreDeCategoria := unaCategoria.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:59'!
fechaYHora
	^fechaYHora.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 17:20'!
initializeWithThisCategory: unNombreDeCategoria andThisClass: unNombreDeClase 
	nombreDeCategoria := unNombreDeCategoria.
	nombreDeClase := unNombreDeClase.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 17:24'!
initializeWithThisCategoryName: unNombreDeCategoria andThisClassName: unNombreDeClase 
	nombreDeCategoria := unNombreDeCategoria.
	nombreDeClase := unNombreDeClase.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 17:18'!
nombreDeCategoria
	^nombreDeCategoria.! !

!Cambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 17:19'!
nombreDeClase
	^nombreDeClase.! !

Object subclass: #SistemaDeCambios
	instanceVariableNames: 'unidadesDeTrabajoCerradas unidadDeTrabajoActiva systemAnnouncer autor reloj'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SistemaDeCambios class methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:20'!
newFor: unSystemAnnouncer 
	^self new initializeWith: unSystemAnnouncer.! !

!SistemaDeCambios class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:01'!
newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	^self new initializeWith: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/24/2013 21:53'!
cerrarUnidadDeTrabajoActiva
	self unidadActiva cerrar.
	^self! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:48'!
handle: unEvento
	self registrarCambio: (Cambio esteTipo: autor fullName aEstaHora: reloj now hizo: unEvento ).
	"self unidadActiva registrarCambio: (Cambio for: unEvento) ."! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:34'!
initialize 
	unidadesDeTrabajoCerradas := OrderedCollection new.
	unidadDeTrabajoActiva := UnidadDeTrabajoReal new.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:40'!
initializeWith: unSystemAnnouncer 
	unidadesDeTrabajoCerradas := OrderedCollection new.
	unidadDeTrabajoActiva := UnidadDeTrabajoReal new.
	systemAnnouncer := unSystemAnnouncer.
	systemAnnouncer on: ClassAdded do: [ :unEvento |  self handle: unEvento ].! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:05'!
initializeWith: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	systemAnnouncer := unSistemaDeAnuncios.
	autor := unAutor.
	reloj := unReloj.
	systemAnnouncer on: ClassAdded do: [ :unEvento |  self handle: unEvento ].
	^self.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 15:28'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	[ unidadDeTrabajoActiva registrarCambio: unCambio]
		on: UnidadDeTrabajoException
		do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadDeTrabajoActiva.
		unidadesDeTrabajoCerradas  add: unidadDeTrabajoActiva.
		unidadDeTrabajoActiva := nuevaUnidadActiva.
		unidadDeTrabajoActiva registrarCambio: unCambio ].
! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:10'!
todosLosCambios
	^self unidadActiva todosLosCambios.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/16/2013 21:41'!
unidadActiva
	"devuelve la unidad de trabajo activa"
	^unidadDeTrabajoActiva.
	! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:43'!
unidadesDeTrabajo
	|todasLasUnidadesDeTrabajo|
	todasLasUnidadesDeTrabajo := unidadesDeTrabajoCerradas asSet.
	todasLasUnidadesDeTrabajo add: unidadDeTrabajoActiva.
	^todasLasUnidadesDeTrabajo.! !

Object subclass: #UnidadDeTrabajo
	instanceVariableNames: 'cambios cerrada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
noSePuedeRegistrarCambios
	^'No se puede registrar cambios en esta unidad de trabajo.'.! !

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 23:30'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	[ unidadActiva registrarCambio: unCambio]
	on: Error
	do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadActiva.
		unidadesCerradas add: unidadActiva.
		unidadActiva := nuevaUnidadActiva.
		unidadActiva registrarCambio: unCambio ].
	^self
! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
cerrar
	cerrada := true.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
estaCerrada
	^cerrada.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
initialize
	cambios := OrderedCollection new.
	cerrada := false.
	^self! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 15:29'!
registrarCambio: unCambio
	self estaCerrada ifTrue: [ UnidadDeTrabajoException  signal: self class noSePuedeRegistrarCambios]. 
	cambios add: unCambio.
	^self.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
todosLosCambios
	^cambios.! !

UnidadDeTrabajo subclass: #UnidadDeTrabajoInicial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo subclass: #UnidadDeTrabajoReal
	instanceVariableNames: 'padre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoReal class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:38'!
newWith: unaUnidadDeTrabajo
	^self new initializeWith: unaUnidadDeTrabajo.! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:39'!
initializeWith: unaUnidadDeTrabajo
	padre := unaUnidadDeTrabajo.
	^self.
	! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:53'!
padre
	^ padre! !

TestCase subclass: #ChangesTest
	instanceVariableNames: 'diccionarioDeAcciones nombreDelAutor fechaYHoraTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:37'!
algunaUnidadDeTrabajo
	^UnidadDeTrabajoInicial  new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
autorTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:06'!
cambio01
	^1.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:42'!
classAdded: aClass inCategory: aCategoryName 
	(diccionarioDeAcciones at: ClassAdded) value: (ClassAdded class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:48'!
fullName
	^nombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:06'!
fullName: unNombreDelAutor 
	nombreDelAutor := unNombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:37'!
initialize 
	diccionarioDeAcciones := Dictionary new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:10'!
now
	^fechaYHoraTest.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:41'!
on: unTipoDeEvento do: aBlockClosure 
	
	diccionarioDeAcciones at: unTipoDeEvento put: aBlockClosure.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
relojTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:08'!
setear: aDateAndTime 
	fechaYHoraTest := aDateAndTime.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:55'!
test001LaUnidadDeTrabajoInicialNoSabeResponderElMensajePadre
	| unaUnidadDeTrabajoInicial |
	unaUnidadDeTrabajoInicial := UnidadDeTrabajoInicial new.
	self should: [ unaUnidadDeTrabajoInicial padre ]
			raise:  MessageNotUnderstood 
			withExceptionDo: [ :aMessageNotUnderstood  | aMessageNotUnderstood messageText = '#padre' ]
! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'maxi 9/23/2013 19:07'!
test002UnaUnidadDeTrabajoSeCreaSinCambiosYAbierta
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.
	
	unaUnidadDeTrabajo := UnidadDeTrabajoInicial new.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'Maxii 9/27/2013 15:06'!
test003UnaUnidadDeTrabajoQueRegistraUnCambioNoEstaVacia
	
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo registrarCambio: self cambio01.
	self deny: unaUnidadDeTrabajo todosLosCambios isEmpty.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'Maxii 9/27/2013 15:06'!
test004RegistrarUnCambioEnUnidadCerradaLanzaUnaExcepcion
	
	| unaUnidadDeTrabajo |
	
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo cerrar.

	self should: [ unaUnidadDeTrabajo registrarCambio: self cambio01 ] raise: Error withExceptionDo:  [ :anError | anError messageText  = UnidadDeTrabajoReal noSePuedeRegistrarCambios.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty ].

	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'maxi 9/23/2013 19:08'!
test005UnSistemaDeCambiosSeInicializaConUnaUnidadDeTrabajoActivaVacia
	
	| unSistemaDeCambios |
	unSistemaDeCambios := SistemaDeCambios new.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios unidadActiva todosLosCambios size = 0.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/27/2013 15:06'!
test006ElSistemaRegistraElCambioEnLaUnidadActiva
	
	| unSistemaDeCambios unaUnidadDeTrabajo |
	unSistemaDeCambios := SistemaDeCambios new.
	unSistemaDeCambios registrarCambio: self cambio01.
	unaUnidadDeTrabajo := unSistemaDeCambios unidadActiva. 
	self assert: unaUnidadDeTrabajo todosLosCambios size = 1.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'maxi 9/24/2013 21:54'!
test007ElSistemaAlCerrarLaUnidadActivaNoCreaUnaUnidadNueva
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:54'!
test007UnaunidadDeTrabajoRealConoceASuPadre
	| unaUnidadDeTrabajoPadre unaUnidadDeTrabajo |
	unaUnidadDeTrabajoPadre := self algunaUnidadDeTrabajo.
	unaUnidadDeTrabajo  := UnidadDeTrabajoReal newWith: unaUnidadDeTrabajoPadre.
	self assert: (unaUnidadDeTrabajo padre = unaUnidadDeTrabajoPadre).! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'maxi 9/24/2013 22:24'!
test008ElSistemaAlCerrarLaUnidadActivaSoloTieneUnidadesDeTrabajoCerradas
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: ( unSistemaDeCambios unidadesDeTrabajo allSatisfy: [ :unaUnidadDeTrabajo | unaUnidadDeTrabajo estaCerrada ] ).! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'Maxii 9/28/2013 17:35'!
test009ElSistemaRegistraLosCambiosDeTipoClassAdded
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios newFor: self unSystemAnnouncer.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	
	self unSystemAnnouncer classAdded: ChangesTest inCategory: #'DAO-TP-Changes'.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios todosLosCambios size = 1.
	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unCambio | unCambio nombreDeClase = 'ChangesTest' and: unCambio nombreDeCategoria = 'DAO-TP-Changes' ] ).
	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 9/28/2013 15:22'!
test010ElSistemaDebeCrearUnaUnidadCuandoLaActualEsteCerradaYSeRegistreUnCambio
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios newFor: self unSystemAnnouncer.

	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.

	"Se llama a unSistemaDeCambios registrarCambio:"
	self unSystemAnnouncer classAdded: ChangesTest inCategory: #'DAO-TP-Changes' .
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
	self assert: unSistemaDeCambios todosLosCambios size = 1.

	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastianGarbi 9/28/2013 18:57'!
test011UnCambioDebeSaberEnQueMomentoFueRealizadoYPorQuien
	
	| unSistemaDeCambios unReloj unAutor unSistemaDeAnuncios |
	
	unReloj := self relojTest.
	unAutor := self autorTest. 
	unSistemaDeAnuncios := self unSystemAnnouncer.
	unSistemaDeCambios := SistemaDeCambios newFor: unSistemaDeAnuncios andThisAuthor: unAutor andThisTime: unReloj.
	
	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	
	unSistemaDeAnuncios classAdded: ChangesTest inCategory: #'DAO-TP-Changes'.

	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unCambio | (unCambio autor = 'Seba') and: unCambio fechaYHora = unReloj now ] ).
	! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:11'!
tipoDelCambio01
	^'Agregar'.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:11'!
unSystemAnnouncer
	^self.! !
